! function(a) {
    "use strict";
    "function" == typeof define && define.amd ? define(["jquery"], a) : "undefined" != typeof exports ? module.exports = a(require("jquery")) : a(jQuery)
}(function(a) {
    "use strict";
    var Waterfall = (function() {
        function c(dom, d) {
            var e = this;
            e.$dom = a(dom);
            e.defaults = {
                col: 4,
                speed: 300,
                breakpoints: [{
                        breakpoint: 1440,
                        setting: {
                            col: 3
                        }
                    },
                    {
                        breakpoint: 1199,
                        setting: {
                            col: 2
                        }
                    },

                    {
                        breakpoint: 768,
                        setting: {
                            col: 1
                        }
                    },
                ]
            }


            e.breakpoints = [],
                e.breakpointSettings = [],
                e.options = a.extend({}, e.defaults, d),
                e.init()
        }
        return c
    })();

    Waterfall.prototype.init = function() {
        var that = this;
        var $waterfall = that.$dom;
        var $parents = a(window)
        if (that.options.parentsDom) {
            $parents = a(that.options.parentsDom)
        }
        that.windowWidth = $parents.width();
        that.windowHeight = $parents.height();

        that.computedOptionsHandle(function() {
            that.draw();
        });

        $parents.resize(function() {
            clearTimeout(that.resizeTimer);
            that.resizeTimer = setTimeout(function() {
                that.resize();
            }, 100);
        });
        setTimeout(function() {
            $parents.scroll(function() {

                if ($waterfall.hasClass('isfinish') || $waterfall.hasClass('isloading')) {
                    return;
                }
                that.parentsHeight = $parents.height();
                that.parentsScrollTop = $parents.scrollTop();

                that.parentsScrollHeight = $waterfall.position().top + $waterfall.outerHeight();

                if ((that.parentsScrollTop + that.parentsHeight + 10 >= that.parentsScrollHeight)) {


                    if ($waterfall.hasClass('isfinish') || $waterfall.hasClass('isloading')) {
                        return;
                    }
                    $waterfall.addClass('isloading')
                    that.options.reachBottom && that.options.reachBottom(that.$dom, function() {
                        that.draw();
                    });
                }

            });
        }, 100);

    }

    Waterfall.prototype.copy = function(obj) {
        return JSON.parse(JSON.stringify(obj));
    }

    Waterfall.prototype.resize = function() {
        var that = this;

        var $parents = a(window)
        if (that.options.parentsDom) {
            $parents = a(that.options.parentsDom)
        }
        that.windowWidth = $parents.width();
        that.windowHeight = $parents.height();
        that.computedOptionsHandle(function() {
            that.redraw();
        });
    }

    // 计算options
    Waterfall.prototype.computedOptionsHandle = function(callback) {
        var that = this;

        that.options.breakpoints && this.options.breakpoints.sort(function(a, c) {
            return c.breakpoint - a.breakpoint
        });

        that.computedOptions = that.copy(that.options);

        for (var i = 0; i < that.computedOptions.breakpoints.length; i++) {
            var item = that.options.breakpoints[i];
            if (item.breakpoint > that.windowWidth) {
                that.computedOptions = a.extend({}, that.computedOptions, item.setting);
            }
        }
        var className = 'col-' + that.computedOptions.col;

        if (!that.$dom.hasClass(className)) {
            that.$dom.removeClass('col-1 col-2 col-3 col-4 col-5 col-6').addClass(className);


            that.cols = [];
            for (var i = 0; i < that.computedOptions.col; i++) {
                that.cols.push(0);
            }

        }
        callback();
    }

    Waterfall.prototype.redraw = function() {
        var that = this;

        var $waterfall = this.$dom;

        var col = that.computedOptions.col;
        that.cols = [];
        for (var i = 0; i < that.computedOptions.col; i++) {
            that.cols.push(0);
        }
        $waterfall.removeClass('isloaded').addClass('isloading');
        $waterfall.find('.item').each(function() {
            var $item = a(this)
            $item.removeClass('nodraw loaded')

            var min = that.cols.reduce(function(x, y) {
                return x < y ? x : y
            });

            var itemHeight = Math.round($item.outerHeight());

            var index = that.cols.indexOf(min);
            if (index < 0 || min == NaN) {
                return;
            }
            $item.css({
                left: ((100 / col) * index).toFixed(5) + '%',
                top: min + 'px'
            }, that.options.speed || 300);
            that.cols[index] = that.cols[index] + itemHeight;

            var max = that.cols.reduce(function(x, y) {
                return x >= y ? x : y
            });

            $waterfall.find('.waterfall').css({
                'height': max + 'px'
            });

            $item.addClass('loaded');
        });
        $waterfall.removeClass('isloading').addClass('isloaded');

    }

    // 计算位置
    Waterfall.prototype.computedPosition = function() {
        var that = this;

        var $waterfall = this.$dom;

        var col = that.computedOptions.col;
        $waterfall.find('.item.nodraw').each(function() {
            var $item = a(this)

            var min = that.cols.reduce(function(x, y) {
                return x < y ? x : y
            });

            var itemHeight = Math.round($item.outerHeight());
            var index = that.cols.indexOf(min);


            if (index < 0 || min == NaN) {
                return;
            }

            $item.css({
                left: ((100 / col) * index).toFixed(5) + '%',
                top: min + 'px'
            });

            $item.removeClass('nodraw')

            that.cols[index] = that.cols[index] + itemHeight;

            var max = that.cols.reduce(function(x, y) {
                return x >= y ? x : y
            });

            $waterfall.find('.waterfall').css({
                'height': max + 'px'
            });
        });


    }
    Waterfall.prototype.draw = function() {
        var that = this;

        var $waterfall = this.$dom;

        if ($waterfall.hasClass('isfinish')) {
            return;
        }
        $waterfall.addClass('isloading')

        var notloadLength = $waterfall.find('.item:not(.loaded)').length;
        var loadCount = 0;

        $waterfall.find('.item:not(.loaded)').each(function() {
            var $item = a(this)
            var $img = a(this).find('img');

            /**
             * @function: imgLoadFullCallback
             * @desc  : 图片加载完之后触发的事件
             */
            function imgLoadFullCallback() {
                // 如果加载完成
                if (loadCount == notloadLength) {
                    // 计算位置
                    that.computedPosition();
                    // 添加完成的类
                    $waterfall.removeClass('isloading').addClass('isloaded');
                }
            }
            if ($img.length > 0) {
                $img.attr({
                    'src': $img.data('src')
                });
                $img.on('load', function() {
                    $item.addClass('loaded nodraw');
                    loadCount++;
                    imgLoadFullCallback();
                })
                $img.on('error', function() {
                    $item.addClass('loaded error nodraw');
                    loadCount++;
                    imgLoadFullCallback();
                })
            } else {
                loadCount++;
                $item.addClass('loaded nodraw');
                imgLoadFullCallback();
            }
        });
    }

    a.fn.waterfall = function() {
        var f, g, a = this,
            c = arguments[0],
            d = Array.prototype.slice.call(arguments, 1),
            e = a.length;
        for (f = 0; e > f; f++)
            if ("object" == typeof c || "undefined" == typeof c ? a[f].waterfall = new Waterfall(a[f], c) : g = a[f].waterfall[c].apply(a[f].waterfall, d),
                "undefined" != typeof g)
                return g;
        return a
    }
});